package Globals;

import java.lang.*;
import java.util.StringTokenizer;
import java.text.DecimalFormat;







/** Collection of static methods and fields.
    Be aware, con() methods can be slow.
*/

public class GS {

static public boolean deb = false;
static public String defaultFontName = "Dialog";
static public String defaultMonospacedFontName = "Dialog";





/** Cyclic log for program main events */
static public String[] mainLog       = new String[1000];
static public      int mainLogPos    = -1;
static public  boolean mainLogFilled = false;

static public void logToMain(String s) {
       if( ++mainLogPos >= mainLog.length-1 ) {
             mainLogPos    = 0;
             mainLogFilled = true;
       } 
       if( 0 == mainLogPos ) {
           if( mainLogFilled ) {
               mainLog[mainLogPos] = "S Y S T E M   C Y C L I C   L O G   C O N T I N U E D:";
           }else{
               mainLog[mainLogPos] = "S Y S T E M   L O G   B E G I N N I N G:";
           }
           mainLogPos++;
       }
       mainLog[mainLogPos] = s;
       if( mainLogFilled ) {
           if( mainLog.length-1 > mainLogPos ) {
               mainLog[mainLogPos+1] = "S Y S T E M   C Y C L I C   L O G   B E G I N N I N G:";
           } 
       }
}






/** Wrapper to system console */
static public void con(String s) {
        String s1 = "      " + System.currentTimeMillis();
        int wLen = s1.length();
        s1 = s1.substring( wLen - 7, wLen-1 );
        String s2 =Thread.currentThread().getName() + "            ";
        s2 = s1 + " " + s2.substring ( 0, 12 ) + " " + s;
        logToMain(s);
        System.out.println(s);
}


/** Wrapper to system console 
    The same as con but input is string's array 
*/
static public void con(String[] s) {
       con(s, s.length);
}

/** Wrapper to system console 
    The same as con but input is string's array and
    resticted by lastIndexToPrint.
*/
static public void con(String[] s, int lastIndexToPrint) {
    for(int i=0; i<s.length; i++) {  
        if(i > lastIndexToPrint) return;   
        String s1 = "      " + System.currentTimeMillis();
        int wLen = s1.length();
        s1 = s1.substring( wLen - 7, wLen-1 );
        String s2 =Thread.currentThread().getName() + "            ";
        s2 = s1 + " " + s2.substring ( 0, 12 ) + " " + s[i];
        logToMain(s2);
        System.out.println(s2);
    }
}







/** Console multistring.
    String s can have \n inside. It will be tokenized by \n and printed
    line by line.
*/
static public void com(String s) {
     
    //Will be code faster if to declare st at class level:
    //StringTokenizer st;
    //?
    StringTokenizer st = new StringTokenizer(s,"\n");

    while(st.hasMoreTokens()) {
        String s0 = st.nextToken();
        String s1 = "      " + System.currentTimeMillis();
        int wLen = s1.length();
        s1 = s1.substring( wLen - 7, wLen-1 );
        String s2 =Thread.currentThread().getName() + "            ";
        s2 = s2.substring ( 0, 12 );
        s2 = s1 + " " + s2 + " " + s0; 
        System.out.println(s2);
   }
}

/** Debug string s to console */
static public void dcon(String s) {
       if ( deb ) con(s);
}
/** Debug array of strings s to console */
static public void dcon(String[] s) {
       if ( deb ) con(s);
}



//Formatting
//public static DecimalFormat df3 = new DecimalFormat("0.000E0"); 
/** Outputs len-significant mantissa digits.
    This proc is horrible. But I don't have time to search Java docs. 
*/
public static String scF(double d, int len) {
       String sft = "0.000000000000000000000000000000000000000".substring(0,len+1)+"E0";
       DecimalFormat df = new DecimalFormat(sft); 
       return df.format(d);
}


} //Applet End