package Ightaria;


import java.awt.image.*;

import java.awt.*;
import Globals.*;
import DrawTexts.*;
import DrawHills.*;
import CalculusAndVectors.Vec;
import Statistics.Stat;





//*************************************************************************
//      C l a s s    S c e n a r i o
//*************************************************************************
/**<pre>

    This class comprises at least two functionalities:
    Primary scenario dialog with driver.
    Dialog/commands with software engine.

    This class contains software version for an entire Ightaria package.
    The version is saved in constant "VERSION".

</pre>*/
public class Scenario {



public static final String VERSION     = "1.0.12.1";
public static final String[] COPYRIGHT = { "Ightaria-G license is GNU GPL. August 2007. ",
                                           "Granted by Ighabitants in honor of the First Contact.",
                                           "Home:  www.Landkey.net/Ightaria.       Suggestions and Questions:  Lostant-Landkey.net"
                                         };


/** Program state detection variables.
    Used to detect stops/initializations/reloads/cleanups.
*/
    public static  int nonInitializedInt;
    public static SPad nonInitializedSPad;
    public static  int initializedInt = 2;



/** W e l c o m e   M e s s a g e */
/** Duration from beginning of the scenario */ 
static final int welcomeMESSAGE_DURATION = 100;
static       boolean welcomeMessagePrinted   = false;

//Auxilary: 
static    int grandMessageFrameStart; //Master flag of subscenario.
static    int grandMessageDuration;
static    int grandMessageFarOrFront;
static String grandMessageString;
static   Font grandMessageFont;
static    int grandMessageLength;



//L e v e l s    a n d   f l a g s
public static final String[] levelTitle =  { "Ancestor", "Baby Ightarian", "Navigation Expert", "HomeFold Conqueror" };
public static final int      levAncestor           =0;
public static final int      levJustBorn           =1;
public static final int      levNavigationExpert   =2;
public static final int      levHFConqueror        =3;
public static       int      level                 =levAncestor;

static String    sL1        = "startup";
static String    sL2        = "";
static String    sL3        = "";

static final int EV_NOEVENT           = 0;
static final int EV_MESSAGEFROMDRIVER = 1;
static final int EV_MESSAGEFROMBRIDGE = 2;

public static boolean cheatEnabled = false;



/** C r i t i c a l   A n s w e r s */
public static String aDistanceIs = "a:euclidean distance to azoruus is";

/** set at constructor-time */
public static double aDistanceIsD;   

public static final String aRadiusIs    = "a:radius is";
public static final String aRadiusIs2   = "a:radius of the universe is";
public static final String aCurvatureIs = "a:curvature is";
/** Debug mode switch */
private static final String cheatCode   = "cheatformate";  





/** N o t   C o m m o n l y    Accepted Answers In HomeFold  */
public static String[] aNonCommon = {
       "A:Radius of the Universe is infinite",                  //0
       "A:Universe is flat. Curvature Radius is oo",           //1
       "A:Universe is Euclidean plane",                         //2
       "A:Universe is Hyperbolic. Distance to seddle point is", //3
       "A:HomeFold is torus. Maximum Radius is"                 //4 
};



/** S t a n d a r d   R e p l i e s */
static final String S_WHAT    = "Your message seems too advanced for us ... Didn't you make a typo? ...";
static final String S_WEKNOW  = "We already know this ... ";



/** G U I   S c r a t c h   P a d s */
/*
//Was working:
private static SPad sPb = SPad.sPad[SPad.b_];
private static SPad sPa = SPad.sPad[SPad.a_];
*/
private static SPad sPb;
private static SPad sPa;



/** R e s o u r c e s */

public static final int TXT_NOTHING  = 0;

public static String   quickHelp[]   = new String[500];
public static int quickHelpLength;
public static final int TXT_QUICK_HELP = 1;

public static String   help[] = new String[500];
public static int      helpLength;
public static final int TXT_HELP     = 2;

public static String  introduction[] = new String[500];
public static int     introductionLength;
public static final int TXT_INTRODUCTION = 3;

public static String   level1Help[] = new String[500];
public static int     level1HelpLength;
public static final int TXT_LEVEL1HELP = 4;

public static String       story[] = new String[500];
public static int     storyLength;
public static final int TXT_STORY  = 5;

//Patch: Add System Console here:
public static final int TXT_SYSTEM_CONSOLE = 6;

public static       int txt_Current  = TXT_NOTHING;

//do1b merge sketchImgObs and level1Help in one Vector (array):
//do1b sketchImgObs apparently is one for all
public static               int imgLevelDisplayed;
public static               int imgSketchDisplayed;
public static         Image[][] sketchImg = new Image[4][];
public static ImageObserver[][] sketchImgObs = new ImageObserver[4][];



/** To set/toggle text print from Resources 
    text_Ix == TXT_NOTHING => removes display,
            == txt_Current => removes display
            != txt_Current => sets display to text_Ix
*/
public static void setText( int text_Ix ) {

              if( txt_Current == text_Ix ) {

                  //Already in display ... Turn off:
                  txt_Current = TXT_NOTHING;

              }else{

                  txt_Current = text_Ix;


                  String[] loText   = { "dummy" };
                  int      loLength = 0;
                  Font     loFont   = new Font (GS.defaultFontName, Font.ITALIC, 13 );
       
                  switch(txt_Current) {
                  case TXT_NOTHING:
                  case TXT_QUICK_HELP: 
                       return;
                  case TXT_HELP: 
                       loText = help;
                       loLength = helpLength;
                       loFont   = new Font (GS.defaultMonospacedFontName, Font.PLAIN, 13 );
                       break;
                  case TXT_INTRODUCTION: 
                       loText = introduction;
                       loLength = introductionLength; 
                       break;
                  case TXT_LEVEL1HELP: 
                       loText = level1Help;
                       loLength = level1HelpLength; 
                       loFont   = new Font (GS.defaultMonospacedFontName, Font.PLAIN, 13 );
                       break;
                  case TXT_STORY: 
                       loText = story;
                       loLength = storyLength; 
                       break;

                  case TXT_SYSTEM_CONSOLE: 
                       loFont   = new Font (GS.defaultMonospacedFontName, Font.PLAIN, 11 );
                       if( GS.mainLogPos < 0 ) {
                           //If console is still empty:                             
                           txt_Current = TXT_NOTHING;
                           return;
                       }
                       int loTextSize = GS.mainLogPos+1;
                       if( GS.mainLogFilled ) loTextSize = GS.mainLog.length;
                       SPad.sPad[SPad.C_].setAndScroll( 
                                   GS.mainLog,
                                   loTextSize,
                                   0,3,  
                                   loFont,
                                   new Color( 220<<16|255<<8|220 )
                       ); 
                       return;

                  }


//static public String[] mainLog       = new String[1000];
//static public      int mainLogPos    = -1;
//static public  boolean mainLogFilled = false;



                  //do1b change only Italic, no font itself: 
                  SPad.sPad[SPad.C_].setAndScroll( 
                                   loText,
                                   loLength,
                                   0,3,  
                                   loFont,
                                   new Color( 150<<16|255<<8|255 )
                  ); 
             }
}


/** Do both image and text */
public static void displayText(int flagScrollText) {

       if( SPad.sPad[SPad.P_].scrollImage(flagScrollText) ) return;

       switch(txt_Current) {
       case TXT_NOTHING: return;
       case TXT_QUICK_HELP: Scenario.displayQuickHelp();
                            return;
       case TXT_HELP:       Scenario.displayQuickHelp();
       }
       SPad.sPad[SPad.C_].doScrollString(flagScrollText); 

}




/** L i n k s   t o    s u b o r d i n a t e    o b j e c t s */
public static Pop ppl;



/** W o r k   v a r i a b l e s   a n d   m e t h o d s */
//private static ParsedAnswer pa = new Scenario.ParsedAnswer();
private static String pureCommand; 




public static void initiate() {


    GS.con("Initiating Scenario ... ");


    /** F o r   d e t e c t i o n   of initialization */
        nonInitializedInt  = 2;
        nonInitializedSPad = new SPad(SPad.F_, 0,    0,200,200);
        initializedInt     = 3;



    //I n i t i a l i z e   c o n s t a n t s:
        for(int i=0; i<aNonCommon.length; i++) {
            aNonCommon[i]=aNonCommon[i].toLowerCase();
        }


    //I n i t i a l i z e   v a r i a b l e s:
          //Apparently, sometimes, when web page reloads,
          //the browser does not reinitiate some parameters already
          //changed in previous load:
          //So, to emulate full effect of reload set this:
       level                  = levAncestor;
       
       grandMessageFrameStart = -1;
       //do1 better: forbid such reload at all: don't allow to restart.

       //S k e t c h e s 
        imgLevelDisplayed = -1;
       imgSketchDisplayed = -1;

       sketchImg[2]    = new Image[4];
       sketchImgObs[2] = new ImageObserver[4];
       sketchImg[3]    = new Image[1];
       sketchImgObs[3] = new ImageObserver[1];


       //I n i t i a l i z e   o b j e c t s   w h i c h  depend on other classes in package:
       //So, this classes must be initialized before this class:
       sPb = SPad.sPad[SPad.b_];
       sPa = SPad.sPad[SPad.a_];



       //I n i t i a l i z e   v a r i a b l e s   w h i c h  
       //depend on   c a c l u l a t i o n s   in other classes in package:
       aDistanceIsD = Pop.hills[2].startUpDistance;


}





//**********************************************************
/** M a i n   m e t h o d                                 */
//**********************************************************
public static void dialog(String textResponse, int eventResponse) {

    //GS.con("Entered dialog:" + textResponse + " Event" + eventResponse );
    int i=0;
    String mS="", ms="";

    switch(eventResponse){
    case EV_MESSAGEFROMBRIDGE:
         mS = textResponse.trim();
    case EV_MESSAGEFROMDRIVER:
         mS = SPad.sPad[SPad.focusIx].sb.toString().trim();
         Stat.typingAttempts++;
    }
    ms = mS.toLowerCase();


    if( eventResponse == EV_MESSAGEFROMDRIVER ) {

         if( mS.length() == 0 ) {
             mesc("Apparently, you did not type your message and pressed \"Enter\" ...");
             mes ("When you strike \"Enter\" key, you send the string you typed to us ...");
             return;
         } 
         if(ms.equals("who are you?")) {
            mesc("We are Nutvigators lost beyond this HomeFold ... ");
            mes ("If you already know more than we, we would be glad to learn from you ...");
            mes ("Overwise, as your knowledge progresses, we are eager to assist you ...");
            return;
         }
         if(ms.equals(cheatCode)) {
            cheatEnabled = !cheatEnabled;
            if( cheatEnabled ) {
                mes ("Everything is clear ... ");
            }else{
                mes ("Back to darkness ... ");
            }
            setLevel(level);
            //Shake the pictures:
            HFold.doPaintScratchMaps = true; 
            return;
         }
         if(ms.equals("debformate")) {
            GS.deb = !GS.deb;
            if( GS.deb ) {
                mes ("In debug mode ... ");
            }else{
                mes ("Debug mode disabled ... ");
            }
            return;
         }


         int msLen = ms.length();
         if( msLen > 2 ) {
         if( ms.charAt(1) == ':' ) {

             pureCommand = ms.substring(2);
            
             //=================================
             //  x:messages
             //--------------------------------- 

           if( ms.charAt(0) == 'a' ){

             //=================================
             //  A n s w e r s
             //--------------------------------- 
             Stat.answerAttempts++;
             boolean victory = pa.checkAReply(ms,aDistanceIs, aDistanceIsD);
             if(victory) {
                 setLevel(levNavigationExpert);
                 mesc("Congratulations for deep analysis of the data ...");
                 mes("Your rank is now \"" + levelTitle[level] + "\"." );
                 mes("You can use the number \"" + ((int) aDistanceIsD ) + "\" as a password to your level.");
                 HFold.doPaintScratchMaps = true; 
                 if( Stat.timeOfVictoryToLevel2 < 1 ) {
                     Stat.timeOfVictoryToLevel2 = Bridge.frameNumber;
                 }
                 return;
             }else{
                 if( pa.intDiagnosis >=0 ) return;
             }
                  
             victory = pa.checkAReply(ms,aRadiusIs,HFold.hfRadius);
             if(victory){
                 setConqerorLevelFirstTime();
                 return;
             }else{
                 if( pa.intDiagnosis >=0 ) return;
             }

             victory = pa.checkAReply(ms,aRadiusIs2,HFold.hfRadius);
             if(victory){
                 setConqerorLevelFirstTime();
                 return;
             }else{
                 if( pa.intDiagnosis >=0 ) return;
             }

             victory = pa.checkAReply(ms,aCurvatureIs,1./HFold.hfRadius);
             if(victory){
                 setConqerorLevelFirstTime();
                 return;
             }else{
                 if( pa.intDiagnosis >=0 ) return;
             }


             for(i=0; i<aNonCommon.length; i++){
                        //GS.con("Trying: template="  + aNonCommon[i]);
                        //GS.con("Trying: message ="  + ms);
                        pa.check(ms, aNonCommon[i], 185390362876482.);   //Put bogus numer. It is irrelevant here.
                        //GS.con("str Dignosig ="  + pa.strDiagnosis);
                        if( pa.intDiagnosis >= 0 ) {
                            mesc(mS);
                            switch(i) {
                            case 0: mes("Can you prove this? ... ");           //"A:Radius of the Universe is infinite ", //0
                                    mes("Did you try to travel straight enough far? ...");
                                    mes("Are you sure, you do not reach the place you left? ...");
                                    return; 
                            case 1: 
                            case 2: mes("What makes you think so? ... ");       //"A:Universe is flat. Curvature Radius is oo. ",     //1
                                    mes("Try to make enough big square when drive your Vessel ...");
                                    mes("Will it look perfect on your Flat Map? ...");
                                    mes("Will the final direction be in right angle with starting direction?...");
                                    return;
                            case 3: mes("We cannot to prove or disprove your conjecture ... ");
                                    //"A:Universe is Hyperbolic. Distance to seddle point is "
                                    return;
                            case 4: mes("The life would be too complex on torus ... ");
                                    mes("We hardly can think about this ...");
                                    //"A:HomeFold is torus. Maximum Radius is "             
                                    return;
                            }
                        }
             }  
             mes(S_WHAT);
             return;
             //--------------------------------- 
             //  A n s w e r s
             //=================================


           } // if(ms.charAt(0) == 'a' ){
           else if( ms.charAt(0) == 'e' ) {


             //========================================
             mesc("Software Engine Dialog. e:command");
             //----------------------------------------
             mes("command sent=" + mS);

             if( ms.equals("e:log" ) ) {
                 setText(Scenario.TXT_SYSTEM_CONSOLE);

             }else if( ms.equals("e:triangles") ) {
                SingleHill.flagTrianglesVsSquares = 
                !SingleHill.flagTrianglesVsSquares;
                mes ("flagTrianglesVsSquares=" + 
                     SingleHill.flagTrianglesVsSquares);
             }

             if(cheatEnabled) { //Until not developed.
             if(ms.equals("e:altitude")) {
                Bridge.engAltitude = !Bridge.engAltitude;
                mes ("Observer Altitude Control=" + 
                     Bridge.engAltitude);
             }
             }


             if(ms.equals("e:derivatoraccuracy*10")) {
                HFold.derivatorTrustedGeneralAccuracy *= 10.;
                mes ("Trusted Derivator general accuracy=" + 
                     HFold.derivatorTrustedGeneralAccuracy);
             }else{ if(ms.equals("e:derivatoraccuracy/10")) {
                HFold.derivatorTrustedGeneralAccuracy /= 10.;
                mes ("Trusted Derivator general accuracy=" + 
                     HFold.derivatorTrustedGeneralAccuracy);
             }
             }

             //----------------------------------------- 
             // mesc("Software ...
             //=========================================
             return;
          
           }else if( ms.charAt(0) == 't' ) {
             //========================================
             mesc("Texts ... t:text");
             //----------------------------------------
             mes("Command sent: " + mS);
         
               if(ms.equals("t:story")) {
                  setText(TXT_STORY);
                  return;
               } 

            } else if ( ms.charAt(0) == 's' ) {

              int loLevel  =-1;
              int loSketch =-1;

              //do1b do indexed vershion:
              switch( pureCommand.charAt(0) ) {
              case '2': loLevel = 2;
                        break;
              case '3': loLevel = 3;
                        break;
              }

              switch( pureCommand.charAt(2) ) {
              case '0': if( 2 == loLevel ||
                            3 == loLevel ) 
                            loSketch = 0;
                        break;
              case '1': if( 2 == loLevel ) 
                            loSketch = 1;
                        break;
              case '2': if( 2 == loLevel ) 
                            loSketch = 2;
                        break;
              }
              if( loLevel < 0 || loSketch < 0 ) {
                  mes("Sketch \"" + pureCommand + "\"" +
                      " does not exist ... ");
                  return;
              }
              if( level < loLevel ) {
                  mes("The Sketch " + loLevel + "." + loSketch + 
                      " is not available on Level " + level + " ... ");
                  return;
              }
      
              if( imgSketchDisplayed == loSketch && 
                  imgLevelDisplayed  == loLevel ) {
                  closeSketch();
                  return;
              }

    
              Image loImg = sketchImg[loLevel][loSketch]; 
              if( loImg == null ) {
                  mes("Level " + loLevel  + " Sketch " + loSketch + 
                      " is not available or not loaded yet ... ");
                  return;
              }
              SPad.sPad[SPad.P_].setToPaintImage( loImg,
                                                  sketchImgObs[loLevel][loSketch]);
              mes("Level " + loLevel  + " Sketch " + loSketch + 
                  " dislplayed ...      " +
                  "Reminder: To close sketch: \"Esc\" ...    " +
                  "To Scroll: Ctrl ][+-    ...  " 
                 );
              imgLevelDisplayed  = loLevel;
              imgSketchDisplayed = loSketch;
              return;


           } // if(ms.charAt(0) == 'a' 

           //---------------------------------
           //  x:messages
           //=================================
         } // if( ms.charAt(1) == ':' ) {
         }


  } // if( eventResponse == EV_MESSAGEFROMDRIVER ) {




   //============================================
   //  C h a t t i n g   w i t h    d r i v e r
   //--------------------------------------------
   BreakLevel0:
   switch (level) {


   case levAncestor:

      SPad.focusIx = SPad.N_; 
      SPad.sPad[SPad.focusIx].setFocus();
      mesc ("W e l c o m e  t o  Journey,  G u e s t  . . .    W e l c o m e  t o  Dialog  . . .    W e l c o m e  t o  Research  . . . ");
      mes  ("         For help, press    Ctrl + H   ...       For Intro,    Ctrl + I   ...   "); 
      mes  ("                   MOUSE is NOT used except for focus ...     ");
      mes  ("                            ARROWS are for driving ...       KEYS for typing ...      BACKSPACE for corrections ... ");
      mes  ("This is your little window for messages and commands to Nutdrivers and Hacuter ... ");
      //Too early:  //mes  ("If you are already earned a level, you can enter its passphrase at anytime ..." );


      setLevel(levJustBorn);
      displayQuickHelp();
      sL1   = "startuppassword";
      return;


   case levJustBorn:
      if(eventResponse==EV_MESSAGEFROMDRIVER){
            
           if( pa.checkAReply(ms,"",aDistanceIsD) ){
               setLevel(levNavigationExpert);
               mes("Welcome back aboard, Expert ... " );
               sL1   = "idle";
               return;
           }else{if(  pa.checkAReply(ms,"",HFold.hfRadius)  ){
               setLevel(levHFConqueror);
               mes("Welcome back aboard, Conqueror ... " );
           }else{if(sL1=="startuppassword"){
              mes("You can try passphrase any time later ...");
           }else{ 
              mes(S_WHAT);
           }
           } 
           }
      }
      sL1   = "idle";            
      return;



   case levNavigationExpert:

      if(eventResponse==EV_MESSAGEFROMDRIVER){
         if(  pa.checkAReply(ms,"",aDistanceIsD)  ){ 
            mes("We already know this, Expert ... " );
         }else{if(  pa.checkAReply(ms,"",HFold.hfRadius)  ){
            setLevel(levHFConqueror);
            mes("Welcome back aboard, Conqueror ... " );
           }else{ 
              mes(S_WHAT);
           } 
           }
      }
      sL1 = "idle";
      break;    


   case levHFConqueror:
        if(eventResponse==EV_MESSAGEFROMDRIVER){
           if(  pa.checkAReply(ms,"",aDistanceIsD)  ){ 
             if( level == levNavigationExpert ){
                 mes("Your rank cannot be decreased ... Can you forget what you already learned? ..." );
             }
             }else{if(  pa.checkAReply(ms,"",HFold.hfRadius)  ){
             if( level == levHFConqueror ){
                  mes(S_WEKNOW );
             }else{ 
                  mes("We don't know what to say yet ... " );
             }
           }else{ 
              mes(S_WHAT);
           } 
           }
        }
        sL1 = "idle";
        break;    
   }
   //--------------------------------------------
   //  C h a t t i n g   w i t h    d r i v e r
   //============================================





} //dialog(...




// A u x i l i a r y   m e t h o d s
/** Shortcut for often operations */
private static void setLevel(int setL) {
        level = setL;
        //switch(setL) {
        //case levNavigationExpert:
        Bridge.setLevelLimits();
}

/** Shortcut */
private static void setConqerorLevelFirstTime() {
        setLevel(levHFConqueror);
        mesc("Congratulations for Great Discovery ... Your rank is now \"" + levelTitle[level] + "\"." );
        mes ("Because of the great contribution to Ightarian Science, grateful inhabitants grant you" );
        mes("to use the number \"" + ((int) HFold.hfRadius) + "\" as a password to your level.");
        HFold.doPaintScratchMaps = true; 
        if( Stat.timeOfVictoryToLevel3 < 1 ) {
            Stat.timeOfVictoryToLevel3 = Bridge.frameNumber;
        }
}





/** W o r k   m e t h o d s.    */

/** Made simply for convenience */
public static String title() {
       return(levelTitle[level]);
}

/** Send message to driver */
public static void mes(String s) {
       SPad.sPad[SPad.N_].wr(s);
}
/** Clear talk board and send message to driver */
public static void mesc(String s) {
       SPad.sPad[SPad.N_].wrc(s);
}






/**  W o r k   C l a s s e s  */
private static class pa {

     /** See method check() for value range. */
     public static int intDiagnosis;

     public static String strDiagnosis;
     public static String strDigits;
     public static double accuracy;

     //public ParsedAnswer() {}

     /**<pre> 
         This method does not give any message to driver.
         intDiagnosis < 0 no driver specific answer attempt detected.
                      = 0 driver attempted specific answer.
                      = 1 driver attempted specific answer and reached some accuracy
     </pre>*/
     public static int check(String s, String sampleS, double sampleD) {

        //GS.con("Pars: templateS=" + sampleS + " templateD=" + sampleD);
        if( sampleS.length() > s.length() ) {
            strDiagnosis = "Answer too short ... ";
            intDiagnosis = -3; 
            return(intDiagnosis);
        } 
        if( sampleS.length() != 0  ){
            if( !sampleS.equals(s.substring(0,sampleS.length()))) {
                intDiagnosis = -2; 
                strDiagnosis = "Unknown Answer Text ... ";
                //GS.con(strDiagnosis);
                return(intDiagnosis);
            }
            strDiagnosis = "Answer attempted ... ";
            //GS.con(strDiagnosis);
            intDiagnosis = 0;
        }else{
            intDiagnosis = -1;  //don't know about attempt
            strDiagnosis = "Checking pure numbers ... ";
            //GS.con(strDiagnosis);
        }
       

        if( sampleS.length() < s.length() ) {
            //There is somthing after text, perhaps digits ...
            strDigits = s.substring(sampleS.length());
            try { 
                   accuracy     = 1.;
                   double digitsD = Double.parseDouble(strDigits);
                   accuracy =   Math.abs( (digitsD-sampleD)/sampleD );
                   //GS.con("digitsD=" + digitsD + " accuracy=" + accuracy + " dia=" + strDiagnosis );
                   if( accuracy < .1 ) { 
                       if( intDiagnosis==0  ) intDiagnosis = 1;
                       if( accuracy < .0001 ) intDiagnosis = 1;  //For pure number password.
                       strDiagnosis += ".1-accuracy reached ... "; 
                   }else{
                       strDiagnosis += "No accuracy reached ... "; 
                   }
      
            } catch( Exception e ) {
                   strDiagnosis += "Invalid Number, \"" + strDigits + 
                                  "\", supplied ... "; 
                   //I don't know how graphics.print will react on "\n":
                   //GS.con(strDiagnosis + "\n" + e.getMessage());
            }
        } 
        return(intDiagnosis);  
     }


     /** Returns true if test passed completely */
     public static boolean checkAReply(String s, String sampleS, double sampleD) {

         switch(check(s,sampleS,sampleD)) {
             case -3:
             case -2: 
             case -1: //GS.con("No detection: " + pa.strDiagnosis);
                      return(false);
             case  0: mes(pa.strDiagnosis);
                      return(false);
             case  1: if( accuracy>.99 ) {
                          mes(pa.strDiagnosis);
                      }else{if( accuracy>.01 ) {
                          mesc("You can treat measured data manually if you like long numbers ...");
                          mes ("However at some conditions, the Derivator can calculate the first derivative Azi(path) ...");
                          return(false);
                      }else{
                          if(accuracy>.001){
                               mesc("You should balance you measurements ...");
                               mes ("Too short path will be out of precision of your Instruments ...");
                               mes ("Too long path can contribute high Taylor members ...");
                               return(false);
                          }else{
                               return(true); //passed completely
                          }
                     }
                     }
        } //switch
        return(false);  //I don't believe, this statement is needed ...
    }

    /* //Accuracy digits:
       //This is a good stuff, but useless now:
                   accuracy =  -(int) 
                                  ( Math.log(  
                                    Math.abs( (digitsD-sampleD)/sampleD )  
                                    )  
                                    /Vec.LG10
                                  ); 
   */

}  //End of inner class ParsedAnswer.



public static void setupGrandMessage(String s, int frameNumber, 
                                     int framesDuration, int farOrFront) {

       grandMessageString     = s;
       SPad  sp  = SPad.sPad[SPad.C_];
       int style = Font.ITALIC+Font.BOLD;
       grandFindSize(s, sp, style);
       grandMessageFrameStart = frameNumber;
       grandMessageFarOrFront = farOrFront;
       grandMessageDuration   = framesDuration;

}


private static void grandFindSize(String s, SPad sp, int style){
       Graphics g = sp.g;
       int yL     = sp.yL;
       int len    = 1;
       //Starting size to check:
       int font_Size = 25;
       String sFN   = GS.defaultFontName;
       Font ft;
       FontMetrics fm;
       while(len<yL*.9) {
             ft  = new Font (sFN, style, (font_Size+1) );
             g.setFont(ft);
             fm = g.getFontMetrics();
             len = fm.stringWidth(s);
             font_Size += 2;
       }
       grandMessageFont = new Font (sFN, style, font_Size);
       g.setFont(grandMessageFont);
       fm = g.getFontMetrics();
       grandMessageLength = fm.stringWidth(s);
}


public static void printGrandMessage(int frameNumber, int farOrFront) {

       if( grandMessageFrameStart < 0 ) return;
       if( grandMessageFarOrFront != farOrFront ) return;

       //Terminator:
       if( grandMessageFrameStart > 0 ) {
           if(grandMessageFrameStart + grandMessageDuration <= frameNumber) {
              //Set "message finished" flag:
              grandMessageFrameStart = -1;
              return;
           }
       }

       SPad  sp  = SPad.sPad[SPad.C_];
       int style = Font.ITALIC+Font.BOLD;

       Graphics g = sp.g;
       g.setFont(grandMessageFont);
       int xPos = (sp.xL - grandMessageLength)/2;

       int normalPhase = 512 * (frameNumber+1-grandMessageFrameStart)/(grandMessageDuration+1);
       int normalHalfPhase = 255 - Math.min(Math.abs(256-normalPhase),255);
       int yPos = (60 - 25 * normalPhase/256 ) * sp.yL / 100;

       int alpha = normalHalfPhase;
       int blue  = alpha;
       Color c = new Color(100,200,blue,alpha); 
       g.setColor(c);
       g.drawString(grandMessageString, xPos, yPos);
       sp.restoreToDefaultFont();
       sp.restoreTextColor();

}

public static void setupWelcomeMessage(int frameStartNumber) {
       if( welcomeMessagePrinted ) return;
       setupGrandMessage("Welcome to Ightaria", frameStartNumber, welcomeMESSAGE_DURATION, 0);
       welcomeMessagePrinted = true;
}












/** Level indicator.
    Initiates system pad and prints level messages.
*/
static public void indicateLevel() {
       sPb.wrc ( "LEVEL " + level + ":  " + title() );
       sPb.wr  ( "Levels available: 1-" + (levelTitle.length-1) );
       sPb.wr  ( "Software version: " + VERSION );
       if(cheatEnabled ) sPb.wr("Cheat enabled ...");

       sPb.wr(" ");
       sPb.wr  ( Thread.currentThread().getName());

} //void indicateLevel


/** Shortcut */
static public void displayQuickHelp() {
       sPa.ClearTerminal();
       sPa.setAndScroll( 
            Scenario.quickHelp,
            Scenario.quickHelpLength,
            0,1,  
            new Font (GS.defaultMonospacedFontName, Font.PLAIN, 11 ),
            new Color( 150<<16|255<<8|255 )
       ); 
}


/** Returns false if nothing has been closed,, and
    Esc key can be reused.
*/
public static boolean closeSketch() {
       if( imgSketchDisplayed < 0 ) return false;
       SPad.sPad[SPad.P_].setToPaintImage( null, null );
       mes("Level " + imgLevelDisplayed  + " Sketch " + 
           imgSketchDisplayed + " closed ... ");
       imgSketchDisplayed = -1;
       imgLevelDisplayed  = -1;
       return true;
}


/** Returns false if nothing has been closed,, and
    Esc key can be reused.
*/
public static boolean closeSketchAndHelp() {
       if( closeSketch() ) return true;
       if( txt_Current != TXT_NOTHING ) {
           setText(TXT_NOTHING);
           return true;
       }
       return false;
}


} //Class End