package Statistics;

import java.lang.*;
import Ightaria.Bridge;
import Ightaria.Vessel;
import Ightaria.HFold;
import Ightaria.Scenario;
import Globals.GS;


/** To improve our impression about Visitor.
    Collect statistics.
*/

public class Stat {


    //----------------------------------------------------------------------
    //Preinternal init:
    //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

    /** Startup logging interval. In frames. 1200 ~ 1 minute */
    private static final int LOGGING_INTERVAL = 1200; 

    private static final String[] SRV_LAN_EXT = { "htm", "asp", "php" };
    private static final              int HTM = 0;
    private static final              int ASP = 1;
    private static final              int PHP = 2;

    //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    //Preinternal init:
    //----------------------------------------------------------------------





    //----------------------------------------------------------------------
    //do1b Possible inaccuracy:
    //     Following parameters are possibly not reinitilized when 
    //     browser reloads Applet, 
    //     so values can be appended to the newly-loaded session:
    //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    public static   int timeOfVictoryToLevel2;
    public static   int timeOfVictoryToLevel3;

    public static   int typingAttempts;      //Enter pressed
    public static   int answerAttempts;      //Specific answer typed and enter pressed
    public static   int fullAnswerAttempts;  //Specific answer typed and enter pressed
    public static   int ordersToMeasure;
    public static   int derivatorIsSetTo90Degrees;
    public static   int derivatorReachedAccuracyDigits;

    public static   int  keyEvents;          //In Bridge

    public static   int helpCalls;
    public static   int helpTime;
    public static   int introTime;
    public static int[] helpLevelCalls;
    public static int[] helpLevelTime;
    public static   int distanceTraveled;
    public static   int farestDistanceReached;
    //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    //do1b Possible inaccuracy:
    //----------------------------------------------------------------------


    //---------------------------------------------------------------------------------
    // Variables
    //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    /** Server language index */ private static       int srvLan;
                                 private static       int nextLoggingFrame;
                                 private static       int loggingInterval;
                                 private static   boolean graciousEndMessageCompleted;
                                 private static    String strReusable;
    //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    // Variables
    //---------------------------------------------------------------------------------
     


 public static void internalInit() {
    srvLan = HTM;
    nextLoggingFrame = -1;
    loggingInterval  = LOGGING_INTERVAL;
    graciousEndMessageCompleted = false;
 }



 /** Set srvLan, index of Server language, depending on input s */
 public static void initServerLanguage(String s) {
    for(int i=0; i<SRV_LAN_EXT.length; i++) {
        if( s.equalsIgnoreCase(SRV_LAN_EXT[i]) ) srvLan = i;
    }
    GS.con("Server Language = " + SRV_LAN_EXT[srvLan] );
 }




 /** Supply statistics to the server.
     end = 0 supply only if time came; 
         = 1 supply ultimately;
         = 2 supply because user ordered end of session.
 */
 public static String supplyStat(int end) {

    if( nextLoggingFrame > Bridge.frameNumber && 0 == end ) return "";
    if( graciousEndMessageCompleted ) return "";

    // Prepare URL-query to send to server:
    strReusable = 
               "S_e_r_v_e_r/Sessions/index." + SRV_LAN_EXT[srvLan] + 
               "?t="  + Bridge.frameNumber + 
               "&fL="  + Vessel.frNuFromLoad   +
               "&L="   + Scenario.level        +
               "&L3=" + timeOfVictoryToLevel3 + 
               "&L2=" + timeOfVictoryToLevel2 +            
               "&a="  + answerAttempts        +
               "&ty=" + typingAttempts        + 
               "&m="  + ordersToMeasure       +
               "&s="  + HFold.Sx              +
               "&k="  + keyEvents             +
               "&h="  + helpCalls             +
               "&i="  + introTime             +  //Not done
               "&d="  + distanceTraveled      +  //Summ of completed moves
               "&f="  + farestDistanceReached +
               "&e="  + end;

    if( HTM == srvLan ) {
        strReusable = "Log to S. with htm-lang. is not developed yet. " +
                      strReusable;               
    } else {
        //Send URL-query:
        strReusable = Vessel.getServerResource(strReusable);
    } 

    if ( 2 == end ) {
         GS.con("Final Server reply = " + strReusable + " No more server calls.");
         graciousEndMessageCompleted = true;
         return ( strReusable );
    } else if ( 1 == end ) {
         loggingInterval = LOGGING_INTERVAL;
         nextLoggingFrame = Bridge.frameNumber + loggingInterval;
         GS.con("Extra Server reply = " + strReusable + 
                " Next reply-message near frame=" + nextLoggingFrame);
    } else if ( nextLoggingFrame <= Bridge.frameNumber ) {
         loggingInterval = loggingInterval * 2 + LOGGING_INTERVAL;
         if( loggingInterval > 18000 ) loggingInterval = 18000;
         nextLoggingFrame = Bridge.frameNumber + loggingInterval;
         GS.con("Normal Server reply = " + strReusable + 
                " Next reply-message near frame=" + nextLoggingFrame);
    } 
    return ( strReusable );

 }


} 